OpenShot Audio Library | OpenShotAudio: juce::AudioSource Class Reference

OpenShot Audio Library | OpenShotAudio 1.0.0

Loading...
Searching...
No Matches
juce::AudioSource Class Referenceabstract

`#include <juce_AudioSource.h>`

Inheritance diagram for juce::AudioSource:

## Public Member Functions
virtual | ~AudioSource ()=default
virtual void | prepareToPlay (int samplesPerBlockExpected, double sampleRate)=0
virtual void | releaseResources ()=0
virtual void | getNextAudioBlock (const AudioSourceChannelInfo &bufferToFill)=0

## Protected Member Functions
| AudioSource ()=default

## Detailed Description

Base class for objects that can produce a continuous stream of audio.

An AudioSource has two states: 'prepared' and 'unprepared'.

When a source needs to be played, it is first put into a 'prepared' state by a call to prepareToPlay(), and then repeated calls will be made to its getNextAudioBlock() method to process the audio data.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

See also
  AudioFormatReaderSource, ResamplingAudioSource

Definition at line 109 of file juce_AudioSource.h.

## Constructor & Destructor Documentation

## ◆ AudioSource()

juce::AudioSource::AudioSource | ( |  | ) |
| protecteddefault

Creates an AudioSource.

Referenced by juce::MixerAudioSource::addInputSource(), juce::ChannelRemappingAudioSource::ChannelRemappingAudioSource(), juce::IIRFilterAudioSource::IIRFilterAudioSource(), juce::MixerAudioSource::removeInputSource(), juce::ResamplingAudioSource::ResamplingAudioSource(), and juce::ReverbAudioSource::ReverbAudioSource().

## ◆ ~AudioSource()

virtual juce::AudioSource::~AudioSource | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ getNextAudioBlock()

virtual void juce::AudioSource::getNextAudioBlock | ( | const AudioSourceChannelInfo & | bufferToFill | ) |
| pure virtual

Called repeatedly to fetch subsequent blocks of audio data.

After calling the prepareToPlay() method, this callback will be made each time the audio playback hardware (or whatever other destination the audio data is going to) needs another block of data.

It will generally be called on a high-priority system thread, or possibly even an interrupt, so be careful not to do too much work here, as that will cause audio glitches!

See also
  AudioSourceChannelInfo, prepareToPlay, releaseResources

Implemented in juce::AudioFormatReaderSource, juce::AudioTransportSource, juce::BufferingAudioSource, juce::ChannelRemappingAudioSource, juce::IIRFilterAudioSource, juce::MemoryAudioSource, juce::MixerAudioSource, juce::ResamplingAudioSource, juce::ReverbAudioSource, and juce::ToneGeneratorAudioSource.

Referenced by juce::AudioFormatWriter::writeFromAudioSource().

## ◆ prepareToPlay()

virtual void juce::AudioSource::prepareToPlay | ( | int | samplesPerBlockExpected,
|  | double | sampleRate )
| pure virtual

Tells the source to prepare for playing.

An AudioSource has two states: prepared and unprepared.

The prepareToPlay() method is guaranteed to be called at least once on an 'unprepared' source to put it into a 'prepared' state before any calls will be made to getNextAudioBlock(). This callback allows the source to initialise any resources it might need when playing.

Once playback has finished, the releaseResources() method is called to put the stream back into an 'unprepared' state.

Note that this method could be called more than once in succession without a matching call to releaseResources(), so make sure your code is robust and can handle that kind of situation.

Parameters

  samplesPerBlockExpected | the number of samples that the source will be expected to supply each time its getNextAudioBlock() method is called. This number may vary slightly, because it will be dependent on audio hardware callbacks, and these aren't guaranteed to always use a constant block size, so the source should be able to cope with small variations.
  sampleRate | the sample rate that the output will be used at - this is needed by sources such as tone generators.

See also
  releaseResources, getNextAudioBlock

Implemented in juce::AudioFormatReaderSource, juce::AudioTransportSource, juce::BufferingAudioSource, juce::ChannelRemappingAudioSource, juce::IIRFilterAudioSource, juce::MemoryAudioSource, juce::MixerAudioSource, juce::ResamplingAudioSource, juce::ReverbAudioSource, and juce::ToneGeneratorAudioSource.

Referenced by juce::MixerAudioSource::addInputSource(), juce::AudioSourcePlayer::setSource(), and juce::AudioTransportSource::setSource().

## ◆ releaseResources()

virtual void juce::AudioSource::releaseResources | ( |  | ) |
| pure virtual

Allows the source to release anything it no longer needs after playback has stopped.

This will be called when the source is no longer going to have its getNextAudioBlock() method called, so it should release any spare memory, etc. that it might have allocated during the prepareToPlay() call.

Note that there's no guarantee that prepareToPlay() will actually have been called before releaseResources(), and it may be called more than once in succession, so make sure your code is robust and doesn't make any assumptions about when it will be called.

See also
  prepareToPlay, getNextAudioBlock

Implemented in juce::AudioFormatReaderSource, juce::AudioTransportSource, juce::BufferingAudioSource, juce::ChannelRemappingAudioSource, juce::IIRFilterAudioSource, juce::MemoryAudioSource, juce::MixerAudioSource, juce::ResamplingAudioSource, juce::ReverbAudioSource, and juce::ToneGeneratorAudioSource.

Referenced by juce::MixerAudioSource::removeInputSource(), and juce::AudioTransportSource::setSource().

The documentation for this class was generated from the following file:

- juce_AudioSource.h